/* Objekte und Prozeduren, 1995 Marcel Bennicke */

ENUM MANN, FRAU               /* zwei Konstanten */

OBJECT person       /* sinnvolle Zusammenfassung */
  groesse,gewicht      /* der Daten einer Person */
ENDOBJECT

PROC eingabe(p:PTR TO person)
  /* ohne Objekt, mte man jede Komponente (groesse,
     gewicht) einzeln als Variable bergeben */
  DEF hilf[10]:STRING

  WriteF('Gre   [cm] : '); ReadStr(stdout,hilf)
  p.groesse:=Val(hilf,NIL)
  /* Eingabe als Zahl in Komponente groesse tun */
  WriteF('Gewicht [kg] : '); ReadStr(stdout,hilf)
  p.gewicht:=Val(hilf,NIL) /* in gewicht speich. */

  WriteF('Geschlecht (m/w): ');ReadStr(stdout,hilf)
  IF StrCmp(hilf,'m')      /* Eingabe = 'm' ? */
    RETURN MANN            /* Prozedur verlassen */
  ELSE                     /* und MANN zurckgeben */
   RETURN FRAU             /* sonst FRAU */
  ENDIF
ENDPROC              /* hier kommen wir niemals an */

PROC main()
  DEF ich:person, geschl, q

  WriteF('Machen Sie Angaben zu ihrer Person:\n\n')

  /* An die Eingabeprozedur wird das Objekt ich
     bergeben; danach stehen in dessen Komponenten
     die Daten; als Rckgabewert erhalten wir das
     Geschlecht des Benutzers */
  geschl:=eingabe(ich)
  q:=ich.groesse/ich.gewicht   /* Quotient bilden */

  /* falls Benutzer ein Mann und der Quotient<2 ist,
     dann 'zu schwer', bei Frauen gilt Quotient<3 */
  IF ((geschl=MANN) AND (q<2)) OR
     ((geschl=FRAU) AND (q<3))
    WriteF('Wie wre es mit einer kleinen Dit?\n\n')
  ELSE
    WriteF('Sie haben das richtige Gewicht!\n\n')
  ENDIF
ENDPROC
